Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml	(copie de travail)
@@ -1,70 +1,21 @@
 <?xml version="1.0" encoding="utf-8"?>
-<Entity parent="template_unit_fauna_hunt_defensive">
-  <Armour>
-    <Hack>3</Hack>
-    <Pierce>4</Pierce>
-    <Crush>5</Crush>
-  </Armour>
-  <Attack>
-    <Melee>
-      <Hack>25.0</Hack>
-      <Pierce>10.0</Pierce>
-      <Crush>20.0</Crush>
-      <MaxRange>6.0</MaxRange>
-      <RepeatTime>1000</RepeatTime>
-      <Bonuses>
-        <BonusCav>
-          <Classes>Cavalry</Classes>
-          <Multiplier>1.5</Multiplier>
-        </BonusCav>
-      </Bonuses>
-    </Melee>
-  </Attack>
+<Entity parent="template_unit_fauna_hunt_defensive_elephant">
   <Footprint>
     <Square width="4.6" depth="9.2"/>
     <Height>4.0</Height>
   </Footprint>
   <Health>
     <Max>300</Max>
   </Health>
   <Identity>
-    <Civ>gaia</Civ>
-    <Classes datatype="tokens">Elephant</Classes>
     <SpecificName>African Bush Elephant</SpecificName>
     <Icon>gaia/fauna_elephant_african_bush.png</Icon>
   </Identity>
-  <Loot>
-    <xp>75</xp>
-  </Loot>
-  <Position>
-    <Anchor>pitch</Anchor>
-  </Position>
   <ResourceSupply>
     <Amount>800</Amount>
     <Type>food.meat</Type>
   </ResourceSupply>
-  <Selectable>
-    <Overlay>
-      <Texture>
-        <MainTexture>circle/256x256.png</MainTexture>
-        <MainTextureMask>circle/256x256_mask.png</MainTextureMask>
-      </Texture>
-    </Overlay>
-  </Selectable>
-  <Sound>
-    <SoundGroups>
-      <select>actor/fauna/animal/elephant_select.xml</select>
-      <order_walk>actor/fauna/animal/elephant_order.xml</order_walk>
-      <order_attack>actor/fauna/animal/elephant_attack.xml</order_attack>
-      <attack>actor/fauna/animal/elephant_attack.xml</attack>
-      <death>actor/fauna/animal/elephant_death.xml</death>
-      <trained>actor/fauna/animal/elephant_trained.xml</trained>
-    </SoundGroups>
-  </Sound>
-  <UnitMotion>
-    <PassabilityClass>large</PassabilityClass>
-  </UnitMotion>
   <VisualActor>
     <Actor>fauna/elephant_african_bush.xml</Actor>
   </VisualActor>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml	(copie de travail)
@@ -1,67 +1,24 @@
 <?xml version="1.0" encoding="utf-8"?>
-<Entity parent="template_unit_fauna_hunt_defensive">
-  <Armour>
-    <Hack>3</Hack>
-    <Pierce>4</Pierce>
-    <Crush>5</Crush>
-  </Armour>
-  <Attack>
-    <Melee>
-      <Hack>22.0</Hack>
-      <Pierce>10.0</Pierce>
-      <Crush>18.0</Crush>
-      <MaxRange>6.0</MaxRange>
-      <RepeatTime>1000</RepeatTime>
-      <Bonuses>
-        <BonusCav>
-          <Classes>Cavalry</Classes>
-          <Multiplier>1.5</Multiplier>
-        </BonusCav>
-      </Bonuses>
-    </Melee>
-  </Attack>
+<Entity parent="template_unit_fauna_hunt_defensive_elephant">
   <Footprint>
     <Square width="4.0" depth="8.0"/>
     <Height>3.5</Height>
   </Footprint>
   <Health>
     <Max>250</Max>
   </Health>
   <Identity>
-    <Civ>gaia</Civ>
-    <Classes datatype="tokens">Elephant</Classes>
     <SpecificName>Asian Elephant</SpecificName>
     <Icon>gaia/fauna_elephant_asian.png</Icon>
   </Identity>
   <Loot>
     <xp>60</xp>
   </Loot>
-  <Position>
-    <Anchor>pitch</Anchor>
-  </Position>
   <ResourceSupply>
     <Amount>650</Amount>
     <Type>food.meat</Type>
   </ResourceSupply>
-  <Selectable>
-    <Overlay>
-      <Texture>
-        <MainTexture>circle/256x256.png</MainTexture>
-        <MainTextureMask>circle/256x256_mask.png</MainTextureMask>
-      </Texture>
-    </Overlay>
-  </Selectable>
-  <Sound>
-    <SoundGroups>
-      <select>actor/fauna/animal/elephant_select.xml</select>
-      <order_walk>actor/fauna/animal/elephant_order.xml</order_walk>
-      <order_attack>actor/fauna/animal/elephant_attack.xml</order_attack>
-      <attack>actor/fauna/animal/elephant_attack.xml</attack>
-      <death>actor/fauna/animal/elephant_death.xml</death>
-      <trained>actor/fauna/animal/elephant_trained.xml</trained>
-    </SoundGroups>
-  </Sound>
   <VisualActor>
     <Actor>fauna/elephant_asian.xml</Actor>
   </VisualActor>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml	(copie de travail)
@@ -1,70 +1,24 @@
 <?xml version="1.0" encoding="utf-8"?>
-<Entity parent="template_unit_fauna_hunt_defensive">
-  <Armour>
-    <Hack>3</Hack>
-    <Pierce>4</Pierce>
-    <Crush>5</Crush>
-  </Armour>
-  <Attack>
-    <Melee>
-      <Hack>20.0</Hack>
-      <Pierce>20.0</Pierce>
-      <Crush>0.0</Crush>
-      <MaxRange>6.0</MaxRange>
-      <RepeatTime>1000</RepeatTime>
-        <Bonuses>
-          <BonusCav>
-            <Classes>Cavalry</Classes>
-            <Multiplier>1.5</Multiplier>
-          </BonusCav>
-        </Bonuses>
-    </Melee>
-  </Attack>
+<Entity parent="template_unit_fauna_hunt_defensive_elephant">
   <Footprint>
     <Square width="3.5" depth="7.0"/>
     <Height>3.0</Height>
   </Footprint>
   <Health>
     <Max>200</Max>
   </Health>
   <Identity>
-    <Civ>gaia</Civ>
-    <Classes datatype="tokens">Elephant</Classes>
     <SpecificName>North African Elephant</SpecificName>
     <Icon>gaia/fauna_elephant_north_african.png</Icon>
   </Identity>
   <Loot>
     <xp>50</xp>
   </Loot>
   <ResourceSupply>
     <Amount>500</Amount>
     <Type>food.meat</Type>
   </ResourceSupply>
-  <Selectable>
-    <Overlay>
-      <Texture>
-        <MainTexture>circle/256x256.png</MainTexture>
-        <MainTextureMask>circle/256x256_mask.png</MainTextureMask>
-      </Texture>
-    </Overlay>
-  </Selectable>
-  <Sound>
-    <SoundGroups>
-      <select>actor/fauna/animal/elephant_select.xml</select>
-      <order_walk>actor/fauna/animal/elephant_order.xml</order_walk>
-      <order_attack>actor/fauna/animal/elephant_attack.xml</order_attack>
-      <attack>actor/fauna/animal/elephant_attack.xml</attack>
-      <death>actor/fauna/animal/elephant_death.xml</death>
-      <trained>actor/fauna/animal/elephant_trained.xml</trained>
-    </SoundGroups>
-  </Sound>
-  <UnitMotion>
-    <WalkSpeed>3.0</WalkSpeed>
-    <Run>
-      <Speed>10.0</Speed>
-    </Run>
-  </UnitMotion>
   <VisualActor>
     <Actor>fauna/elephant_african_forest.xml</Actor>
   </VisualActor>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml	(copie de travail)
@@ -10,10 +10,11 @@
       <Hack>15.0</Hack>
       <Pierce>10.0</Pierce>
       <Crush>0.0</Crush>
       <MaxRange>4.0</MaxRange>
       <RepeatTime>1000</RepeatTime>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
   <Footprint>
     <Square width="3.2" depth="6.4"/>
     <Height>2.0</Height>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna">
-  <Identity>
-  </Identity>
   <Vision>
     <Range>20</Range>
   </Vision>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml	(copie de travail)
@@ -1,9 +1,7 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_breed">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
   <Vision>
     <Range>10</Range>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>aggressive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>defensive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive_elephant.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive_elephant.xml	(nonexistent)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive_elephant.xml	(copie de travail)
@@ -0,0 +1,59 @@
+<?xml version="1.0" encoding="utf-8"?>
+<Entity parent="template_unit_fauna_hunt_defensive">
+  <Armour>
+    <Hack>3</Hack>
+    <Pierce>4</Pierce>
+    <Crush>5</Crush>
+  </Armour>
+  <Attack>
+    <Melee>
+      <Hack>25.0</Hack>
+      <Pierce>10.0</Pierce>
+      <Crush>20.0</Crush>
+      <MaxRange>6.0</MaxRange>
+      <RepeatTime>1000</RepeatTime>
+      <Bonuses>
+        <BonusCav>
+          <Classes>Cavalry</Classes>
+          <Multiplier>1.5</Multiplier>
+        </BonusCav>
+      </Bonuses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
+    </Melee>
+  </Attack>
+  <Identity>
+    <Civ>gaia</Civ>
+    <Classes datatype="tokens">Elephant</Classes>
+  </Identity>
+  <Position>
+    <Anchor>pitch</Anchor>
+  </Position>
+  <Selectable>
+    <Overlay>
+      <Texture>
+        <MainTexture>circle/256x256.png</MainTexture>
+        <MainTextureMask>circle/256x256_mask.png</MainTextureMask>
+      </Texture>
+    </Overlay>
+  </Selectable>
+  <Sound>
+    <SoundGroups>
+      <select>actor/fauna/animal/elephant_select.xml</select>
+      <order_walk>actor/fauna/animal/elephant_order.xml</order_walk>
+      <order_attack>actor/fauna/animal/elephant_attack.xml</order_attack>
+      <attack>actor/fauna/animal/elephant_attack.xml</attack>
+      <death>actor/fauna/animal/elephant_death.xml</death>
+      <trained>actor/fauna/animal/elephant_trained.xml</trained>
+    </SoundGroups>
+  </Sound>
+  <UnitMotion>
+    <PassabilityClass>large</PassabilityClass>
+    <WalkSpeed>3.0</WalkSpeed>
+    <Run>
+      <Speed>10.0</Speed>
+    </Run>
+  </UnitMotion>
+  <VisualActor>
+    <Actor>fauna/elephant_african_forest.xml</Actor>
+  </VisualActor>
+</Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>skittish</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>violent</NaturalBehaviour>
   </UnitAI>
   <Vision>
     <Range>10</Range>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml	(copie de travail)
@@ -1,5 +1,3 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna">
-  <Identity>
-  </Identity>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>aggressive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml	(copie de travail)
@@ -1,9 +1,7 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_wild">
-  <Identity>
-  </Identity>
   <Loot>
     <xp>15</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>defensive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_wild">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml	(révision 18742)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>violent</NaturalBehaviour>