Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_african_bush.xml	(copie de travail)
@@ -16,10 +16,11 @@
         <BonusCav>
           <Classes>Cavalry</Classes>
           <Multiplier>1.5</Multiplier>
         </BonusCav>
       </Bonuses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
   <Footprint>
     <Square width="4.6" depth="9.2"/>
     <Height>4.0</Height>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_asian.xml	(copie de travail)
@@ -16,10 +16,11 @@
         <BonusCav>
           <Classes>Cavalry</Classes>
           <Multiplier>1.5</Multiplier>
         </BonusCav>
       </Bonuses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
   <Footprint>
     <Square width="4.0" depth="8.0"/>
     <Height>3.5</Height>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_elephant_north_african.xml	(copie de travail)
@@ -10,16 +10,17 @@
       <Hack>20.0</Hack>
       <Pierce>20.0</Pierce>
       <Crush>0.0</Crush>
       <MaxRange>6.0</MaxRange>
       <RepeatTime>1000</RepeatTime>
-        <Bonuses>
-          <BonusCav>
-            <Classes>Cavalry</Classes>
-            <Multiplier>1.5</Multiplier>
-          </BonusCav>
-        </Bonuses>
+      <Bonuses>
+        <BonusCav>
+          <Classes>Cavalry</Classes>
+          <Multiplier>1.5</Multiplier>
+        </BonusCav>
+      </Bonuses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
   <Footprint>
     <Square width="3.5" depth="7.0"/>
     <Height>3.0</Height>
Index: binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/gaia/fauna_walrus.xml	(copie de travail)
@@ -10,10 +10,11 @@
       <Hack>15.0</Hack>
       <Pierce>10.0</Pierce>
       <Crush>0.0</Crush>
       <MaxRange>4.0</MaxRange>
       <RepeatTime>1000</RepeatTime>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
   <Footprint>
     <Square width="3.2" depth="6.4"/>
     <Height>2.0</Height>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_breed.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna">
-  <Identity>
-  </Identity>
   <Vision>
     <Range>20</Range>
   </Vision>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_breed_passive.xml	(copie de travail)
@@ -1,9 +1,7 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_breed">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
   <Vision>
     <Range>10</Range>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_aggressive.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>aggressive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_defensive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>defensive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_passive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_skittish.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_hunt">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>skittish</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_hunt_violent.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>violent</NaturalBehaviour>
   </UnitAI>
   <Vision>
     <Range>10</Range>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild.xml	(copie de travail)
@@ -1,5 +1,3 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna">
-  <Identity>
-  </Identity>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_aggressive.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>aggressive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_defensive.xml	(copie de travail)
@@ -1,9 +1,7 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_wild">
-  <Identity>
-  </Identity>
   <Loot>
     <xp>15</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>defensive</NaturalBehaviour>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_passive.xml	(copie de travail)
@@ -1,8 +1,6 @@
 <?xml version="1.0" encoding="utf-8"?>
 <Entity parent="template_unit_fauna_wild">
-  <Identity>
-  </Identity>
   <UnitAI>
     <NaturalBehaviour>passive</NaturalBehaviour>
   </UnitAI>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml	(révision 18740)
+++ binaries/data/mods/public/simulation/templates/template_unit_fauna_wild_violent.xml	(copie de travail)
@@ -5,15 +5,13 @@
       <Hack>1</Hack>
       <Pierce>1</Pierce>
       <Crush>0</Crush>
       <MaxRange>4</MaxRange>
       <RepeatTime>1000</RepeatTime>
-      <RestrictedClasses datatype="tokens">Structure</RestrictedClasses>
+      <RestrictedClasses datatype="tokens">Structure Ship</RestrictedClasses>
     </Melee>
   </Attack>
-  <Identity>
-  </Identity>
   <Loot>
     <xp>20</xp>
   </Loot>
   <UnitAI>
     <NaturalBehaviour>violent</NaturalBehaviour>